<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Role"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.meludi");
final String homeLabEnv = ExtensionsControl.getHomeUrl("net.sf.basedb.labenv.service");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	
	boolean isAdmin = user.getId() == SystemItems.getId(User.ROOT);
	boolean isPatientCurator = false;
	if (!isAdmin)
	{
		try
		{
			Role admin = Role.getById(dc, SystemItems.getId(Role.ADMINISTRATOR));
			isAdmin = sc.isMemberOf(admin);
		}
		catch (RuntimeException ex)
		{}
	}
	try
	{
		ItemQuery<Group> query = Group.getQuery();
		query.restrict(Restrictions.eq(Hql.property("name"), Expressions.string("PatientCurator")));
		List<Group> result = query.list(dc);
		if (result.size() == 1)
		{
			isPatientCurator = sc.isMemberOf(result.get(0));
		}
	}
	catch (RuntimeException ex)
	{}
	
	final String caseName = request.getParameter("caseName");
	final String pageType = Values.getString(request.getParameter("pageType"), "default");
	
	boolean iframe = "iframe".equals(pageType);
	boolean popup = "popup".equals(pageType);
	boolean fullPage = !iframe && !popup;
%>
<base:page type="<%=pageType %>" >
<base:head 
	scripts="~case_summary.js,~../meludi-2.js" 
	styles="path.css,~../css/meludi-2.css,~../css/case_summary.css" 
/>
<base:body data-read-only="1">
	<div id="page-data" class="datacontainer"
		data-case-name="<%=HTML.encodeTags(caseName)%>"
		data-admin="<%=isAdmin ? 1 : 0%>"
		data-patient-curator="<%=isPatientCurator ? 1 : 0%>"
		data-page-type="<%=pageType%>"
		data-home-labenv="<%=HTML.encodeTags(homeLabEnv)%>"
	></div>
	<div id="all-content">
	<%
	if (fullPage)
	{
		%>
		<p:path><p:pathelement id="path-meludi" clazz="pathelement noprint"
			title="" href="<%="../index.jsp?ID="+ID%>"
			/><p:pathelement id="path-case-summary" title="<%="Case summary - " + HTML.encodeTags(caseName)%>" 
			/></p:path>
		<%
	}
	else if (popup)
	{
		%>
		<h1 id="path-case-summary">Case summary - <%= HTML.encodeTags(caseName)%></h1>
		<%
	}
	%>
	<div class="content">
	<form name="meludi" id="wizard" class="wizard">
	<%
	if (fullPage || popup)
	{
		%>
		<div class="filled noprint" id="toolbar">
			<table>
			<tr>
				<th style="padding: 0.5em 0.75em 0.5em 0.75em;">Find another case</th>
				<td><input type="text" class="text auto-init" data-auto-init="focus" style="width: 25em;"
					name="caseName" id="caseName" title="Please enter a case id (&quot;ML&quot; + 5 digits)"></td>
				<td style="padding-left: 0.5em; padding-right: 0.5em; border-right: 1px dotted #A0A0A0; "><base:icon id="btnCaseSummary" image="<%=home+"/images/gonext.png"%>" /></td>
				<%
				if (isAdmin || isPatientCurator)
				{
					%>
					<th style="padding-left: 0.5em; padding-right: 0.5em; border-right: 1px dotted #A0A0A0;">
						<label for="showConfidential">Show confidential information</label>
						<input type="checkbox" id="showConfidential" name="showConfidential">
					</th>
					<%
				}
				%>
				<th style="padding-left: 0.5em; padding-right: 0.5em; border-right: 1px dotted #A0A0A0;">
					<span id="printButton" class="link"><img src="../images/print.png" style="padding-right: 0.5em;">Print version&hellip;</span>
				</th>
				<th style="width: 90%;"></th>
			</tr>
			</table>
		</div>
		<%
	}
	%>
	<div class="hide-confidential" id="all-info" style="display: none;">
		<div id="left-column">
			<div>
				<%
				if (sc.getActiveProjectId() == 0)
				{
					%>
					<div class="messagecontainer note" style="margin-bottom: 20px; font-weight: bold; color: #cc0000;">
						No project has been selected. You may not be able to see all registered information.
					</div>
					<%
				}
				%>
				<div class="info-section" id="case-info">
					<div>
					<table class="info-table">
					<thead>
						<tr id="case.name">
							<th id="case-header">Case</th>
						</tr>
					</thead>
					<tbody id="case-details" class="info-details">
						<tr id="case.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="case.tubeContentType">
							<th>Tube content type</th>
						</tr>
						<tr id="case.mutationAnalysis">
							<th>Mutation analysis</th>
						</tr>
						<tr id="case.site">
							<th>Site</th>
						</tr>
						<tr id="case.projectFocus">
							<th>Project focus</th>
						</tr>
						<tr id="case.nofTubes">
							<th>No. tubes</th>
						</tr>
						<tr id="case.otherPathNote" class="comment dynamic-column">
							<th>Other path note</th>
						</tr>
						<tr id="case.description" class="comment dynamic-column">
							<th>Description</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>

				<div class="info-section" id="patient-info">
					<div>
					<table class="info-table">
					<thead>
						<tr id="patient.name">
							<th id="patient-header">Patient</th>
						</tr>
					</thead>
					<tbody id="patient-details" class="info-details">
						<tr id="patient.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="patient.personalNumber" class="confidential">
							<th>Personal number</th>
						</tr>
						<tr id="patient.allFirstNames" class="confidential">
							<th>All first names</th>
						</tr>
						<tr id="patient.familyName" class="confidential">
							<th>Family name</th>
						</tr>
						<tr id="patient.gender">
							<th>Gender</th>
						</tr>
						<tr id="patient.allCases" class="dynamic-column">
							<th>All cases</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>
				
				<div class="info-section" id="specimen-info">
					<div>
					<table class="info-table">
					<thead>
						<tr id="specimen.name">
							<th id="specimen-header">Specimen</th>
						</tr>
					</thead>
					<tbody id="specimen-details" class="info-details">
						<tr id="specimen.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="specimen.specimenType">
							<th>Specimen type</th>
						</tr>
						<tr id="specimen.storageBox">
							<th>Storage box</th>
						</tr>
						<tr id="specimen.samplingDate">
							<th>Sampling date</th>
						</tr>
						<tr id="specimen.viableTumourCellsPercent">
							<th>&#37; Viab. tumour cells</th>
						</tr>
						<tr id="specimen.plNumber" class="confidential">
							<th>PL-number</th>
						</tr>
						<tr id="specimen.pad" class="confidential">
							<th>PAD/CL</th>
						</tr>
<!--
						<tr id="specimen.remainingQuantity">
							<th>Remaining quantity</th>
						</tr>
						<tr id="specimen.originalQuantity">
							<th>Original quantity</th>
						</tr>
-->
						<tr id="specimen.nofSections">
							<th>No. sections</th>
						</tr>
						<tr id="specimen.operatorDeliveryComment" class="comment dynamic-column">
							<th>Op. delivery comm.</th>
						</tr>
						<tr id="specimen.description" class="comment dynamic-column">
							<th>Description</th>
						</tr>
						<tr id="specimen.startPlate">
							<th>Start plate</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>

			</div>
		</div>
		<div id="right-column">
			<div>
				<div class="info-section" id="rna-info">
					<div>
					<table class="info-table dynamic-columns">
					<thead>
						<tr id="rna.name">
							<th id="rna-header">RNA</th>
						</tr>
					</thead>
					<tbody id="rna-details" class="info-details">
						<tr id="rna.flag" class="dynamic-column">
							<th>Flag</th>
						</tr>
						<tr id="rna.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="rna.storageBox">
							<th>Storage box</th>
						</tr>
						<tr id="rna.extractionDate">
							<th>Extraction date</th>
						</tr>
						<tr id="rna.usedQuantity">
							<th>Used quantity</th>
						</tr>
						<tr id="rna.extractionProtocol">
							<th>Protocol</th>
						</tr>
						<tr id="rna.remainingQuantity">
							<th>Remaining quantity</th>
						</tr>
						<tr id="rna.originalQuantity">
							<th>Original quantity</th>
						</tr>
<!--
						<tr id="rna.ndConc">
							<th>ND Conc.</th>
						</tr>
-->
						<tr id="rna.description" class="comment dynamic-column">
							<th>Description</th>
						</tr>
						<tr id="rna.startPlate">
							<th>Start plate</th>
						</tr>
<!--
						<tr id="rna.qc" class="subtitle">
							<th>QC (last)</th>
						</tr>
						<tr id="rna.nofQc" class="dynamic-column">
							<th>No. QC</th>
						</tr>
						<tr id="rna.qcProtocol" class="dynamic-column">
							<th>Protocol</th>
						</tr>
						<tr id="rna.qcPlate" class="dynamic-column">
							<th>Plate</th>
						</tr>
						<tr id="rna.qcRqs" class="dynamic-column">
							<th>RQS</th>
						</tr>
						<tr id="rna.qcRin" class="dynamic-column">
							<th>RIN</th>
						</tr>
						<tr id="rna.qcDescription" class="comment dynamic-column">
							<th>Description</th>
						</tr>
-->
					</tbody>
					</table>
					</div>
				</div>

				<div class="info-section" id="dna-info">
					<div>
					<table class="info-table dynamic-columns">
					<thead>
						<tr id="dna.name">
							<th id="dna-header">DNA</th>
						</tr>
					</thead>
					<tbody id="dna-details" class="info-details">
						<tr id="dna.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="dna.storageBox">
							<th>Storage box</th>
						</tr>
						<tr id="dna.extractionDate">
							<th>Extraction date</th>
						</tr>
						<tr id="dna.extractionProtocol">
							<th>Protocol</th>
						</tr>
						<tr id="dna.remainingQuantity">
							<th>Remaining quantity</th>
						</tr>
						<tr id="dna.originalQuantity">
							<th>Original quantity</th>
						</tr>
<!--
						<tr id="dna.ndConc">
							<th>ND Conc.</th>
						</tr>
-->
						<tr id="dna.description" class="comment dynamic-column">
							<th>Description</th>
						</tr>
						<tr id="dna.startPlate">
							<th>Start plate</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>

<!--				
				<div class="info-section" id="mrna-info">
					<div>
					<table class="info-table dynamic-columns">
					<thead>
						<tr id="mrna.name">
							<th id="mrna-header">mRNA</th>
						</tr>
					</thead>
					<tbody id="mrna-details" class="info-details">
						<tr id="mrna.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="mrna.storageBox">
							<th>Work plate</th>
						</tr>
						<tr id="mrna.result" class="dynamic-column">
							<th>Plate result</th>
						</tr>
						<tr id="mrna.cleanupDate">
							<th>Cleanup date</th>
						</tr>
						<tr id="mrna.usedQuantity">
							<th>Used quantity</th>
						</tr>
						<tr id="mrna.description" class="comment dynamic-column">
							<th>Description</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>
				
				<div class="info-section" id="cdna-info">
					<div>
					<table class="info-table dynamic-columns">
					<thead>
						<tr id="cdna.name">
							<th id="cdna-header">cDNA</th>
						</tr>
					</thead>
					<tbody id="cdna-details" class="info-details">
						<tr id="cdna.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="cdna.storageBox">
							<th>Work plate</th>
						</tr>
						<tr id="cdna.result" class="dynamic-column">
							<th>Plate result</th>
						</tr>
						<tr id="cdna.synthesisDate">
							<th>Synthesis date</th>
						</tr>
						<tr id="cdna.description" class="comment dynamic-column">
							<th>Description</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>
				
				<div class="info-section" id="lib-info">
					<div>
					<table class="info-table dynamic-columns">
					<thead>
						<tr id="lib.name">
							<th id="lib-header">Library</th>
						</tr>
					</thead>
					<tbody id="lib-details" class="info-details">
						<tr id="lib.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="lib.storageBox">
							<th>Library plate</th>
						</tr>
						<tr id="lib.result" class="dynamic-column">
							<th>Plate result</th>
						</tr>
						<tr id="lib.cleanupDate">
							<th>Cleanup date</th>
						</tr>
						<tr id="lib.remainingQuantity">
							<th>Remaining quantity</th>
						</tr>
						<tr id="lib.originalQuantity">
							<th>Original quantity</th>
						</tr>
						<tr id="lib.barcode.name">
							<th>Tag</th>
						</tr>
						<tr id="lib.ca_size">
							<th>CA_Size</th>
						</tr>
						<tr id="lib.molarity">
							<th>Molarity</th>
						</tr>
						<tr id="lib.adapterFrac">
							<th>Adapter fraction</th>
						</tr>
						<tr id="lib.qubitconc">
							<th>QubitConc</th>
						</tr>
						<tr id="lib.description" class="comment dynamic-column">
							<th>Description</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>
				
				<div class="info-section" id="pooledlib-info">
					<div>
					<table class="info-table dynamic-columns">
					<thead>
						<tr id="pooledlib.name">
							<th id="pooledlib-header">Pooled Library</th>
						</tr>
					</thead>
					<tbody id="pooledlib-details" class="info-details">
						<tr id="pooledlib.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="pooledlib.poolDate">
							<th>Pool date</th>
						</tr>
						<tr id="pooledlib.remainingQuantity">
							<th>Remaining quantity</th>
						</tr>
						<tr id="pooledlib.originalQuantity">
							<th>Original quantity</th>
						</tr>
						<tr id="pooledlib.poolMolarity">
							<th>PoolMolarity</th>
						</tr>
						<tr id="pooledlib.poolConc">
							<th>PoolConc</th>
						</tr>
						<tr id="pooledlib.description" class="comment dynamic-column">
							<th>Description</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>
	
				<div class="info-section" id="sequencingRun-info">
					<div>
					<table class="info-table dynamic-columns">
					<thead>
						<tr id="sequencingRun.name">
							<th id="sequencingRun-header">Sequencing runs</th>
						</tr>
					</thead>
					<tbody id="sequencingRun-details" class="info-details">
						<tr id="sequencingRun.flowCell">
							<th>Flow cell</th>
						</tr>
						<tr id="sequencingRun.clusterDate">
							<th>Cluster date</th>
						</tr>
						<tr id="sequencingRun.startDate">
							<th>Start date</th>
						</tr>
						<tr id="sequencingRun.endDate">
							<th>End date</th>
						</tr>
						<tr id="sequencingRun.result" class="dynamic-column">
							<th>Sequencing result</th>
						</tr>
						<tr id="sequencingRun.description" class="comment dynamic-column">
							<th>Description</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>
-->
				
			</div>
		</div>
	</div>

	<div id="wizard-status"></div>
	
	</form>
	</div>
	<%
	if (popup)
	{
		%>
		<base:buttongroup subclass="dialogbuttons topborder" id="dialogbuttons">
			<base:button id="close" title="Close" />
		</base:buttongroup>
		<%
	}
	%>
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>