var SpecimenTubeReg = function()
{
	var streg = {};
	var debug = 0;
	
	var caseInfo;
	
	var nofTubesIsValid = false;
	var samplingDateIsValid = true;
	var viableTumourCellsPercentIsValid = true;

	var wellIsValid = [];
	
	var restartTimer;
	var restartAt;
	
	// Page initialization
	streg.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', streg.validateStep1);
		Events.addEventHandler('caseName', 'keypress', Wizard.goNextOnTabOrEnter);
		
		// Step 2
		Events.addEventHandler('step-2', 'wizard-initialize', streg.initializeStep2);
		Events.addEventHandler('step-2', 'wizard-validate', streg.validateStep2);
		Events.addEventHandler('nofTubes', 'keypress', Events.integerOnly);
		Events.addEventHandler('nofTubes', 'blur', streg.nofTubesOnChange);
		Events.addEventHandler('arrivalDate', 'blur', Wizard.validateDate);
		Events.addEventHandler('samplingDate', 'blur', streg.samplingDateOnChange);
		Events.addEventHandler('projectFocus', 'change', streg.projectFocusOnChange);
		Events.addEventHandler('site', 'change', streg.siteOnChange);
		Events.addEventHandler('specimenType', 'change', streg.specimenTypeOnChange);
		Events.addEventHandler('viableTumourCellsPercent', 'keypress', Events.integerOnly);
		Events.addEventHandler('viableTumourCellsPercent', 'blur', streg.viableTumourCellsPercentOnChange);
		Events.addEventHandler('otherPathNote', 'keypress', Wizard.goNextOnTab);

		// Step 3
		Events.addEventHandler('step-3', 'wizard-initialize', streg.initializeStep3);
		Events.addEventHandler('step-3', 'wizard-validate', streg.validateStep3);
		
		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('goregister', Wizard.goRegister);
		Buttons.addClickHandler('gostop', streg.stopAutoRestart);
		
		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', streg.submit);

		var url = '../LabelGeneration.servlet?ID='+App.getSessionId();
		url += '&cmd=CountCases';
		Wizard.showLoadingAnimation('Loading cases...');
		Wizard.asyncJsonRequest(url, streg.caseInfoLoadedStep1);
	}

	streg.caseInfoLoadedStep1 = function(response)
	{
		var frm = document.forms['meludi'];	

		var nofCases = response.count;
		if (nofCases == null)
		{
			nofCases = 0;
		}
		var startNum = nofCases + 1;
		// Pad number with leading zeros to get 5 digits
		startNum = String('00000' + startNum).slice(-5);
		var startCase = 'ML' + startNum;
		frm.caseName.value = startCase;
		
		Doc.show('step-1');
		Doc.show('gonext');
	}

	streg.validateStep1 = function(event)
	{
		var frm = document.forms['meludi'];
		
		var caseName = frm.caseName.value;
		var caseIsValid = false;
		Wizard.setInputStatus('caseName');
		if (caseName == '')
		{
			Wizard.setInputStatus('caseName', 'invalid', 'Missing');
			frm.caseName.focus();
		}
		else if (!Meludi.isValidCaseName(caseName))
		{
			Wizard.setInputStatus('caseName', 'invalid', 'Only name = "ML" + 5 digits is allowed.');
			frm.caseName.focus();
		}
		else
		{
			Wizard.setInputStatus('caseName', 'valid');
			caseIsValid = true;
		}
		
		// If not valid, we prevent the wizard from moving to the next step
		if (!caseIsValid) event.preventDefault();
	}
	
	streg.initializeStep2 = function()
	{
		var frm = document.forms['meludi'];	
		var caseName = frm.caseName.value;
		var url = '../SpecimenTubeRegistration.servlet?ID='+App.getSessionId();
		url += '&cmd=GetCaseInfo';
		url += '&caseName=' + encodeURIComponent(caseName);
		
		Wizard.showLoadingAnimation('Loading information about case...');
		Wizard.asyncJsonRequest(url, streg.caseInfoLoaded);
	}
	
	
	streg.caseInfoLoaded = function(response)
	{
		var frm = document.forms['meludi'];	
		caseInfo = response.caseInfo;
		
		Wizard.setCurrentStep(2);
		Doc.show('gocancel');
		Doc.show('gonext');
		
		frm.arrivalDate.value = Dates.formatDate(new Date(), 'yyyyMMdd');

		frm.nofTubes.focus();
		frm.nofTubes.setSelectionRange(0,1);
	}
	
	streg.nofTubesOnChange = function()
	{
		nofTubesIsValid = false;

		var frm = document.forms['meludi'];
		var nofTubes = frm.nofTubes.value;
		
		if (nofTubes == '')
		{
			Wizard.setInputStatus('nofTubes', 'invalid', 'Missing');
			return;
		}
		if (parseInt(nofTubes) < 1)
		{
			Wizard.setInputStatus('nofTubes', 'invalid', 'Must be at least 1');
			return;		
		}
		Wizard.setInputStatus('nofTubes', 'valid');
		nofTubesIsValid = true; 
	}

	streg.samplingDateOnChange = function()
	{
		var frm = document.forms['meludi'];
		
		samplingDateIsValid = false;
		Wizard.setInputStatus('samplingDate');
		
		var samplingDate = frm.samplingDate.value;

		if (samplingDate != '')
		{
			// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.
			samplingDate = Meludi.autoFillDate(samplingDate);
			frm.samplingDate.value = samplingDate;
		
			var d = Dates.parseString(samplingDate, 'yyyyMMdd');
			if (d == null)
			{
				Wizard.setInputStatus('samplingDate', 'invalid', 'Not a valid date');
				return;
			}
			
			var today = new Date();
			if (d.getTime() > today.getTime())
			{
				Wizard.setInputStatus('samplingDate', 'invalid', 'Future date is not valid');
				return;
			}

			var arrivalDate = frm.arrivalDate.value;
			if (arrivalDate != '' && arrivalDate < samplingDate)
			{
				Wizard.setInputStatus('samplingDate', 'invalid', 'Arrival date is before sampling date');
				return;
			}

			Wizard.setInputStatus('samplingDate', 'valid');
		}
		samplingDateIsValid = true;
	}
	
	streg.projectFocusOnChange = function()
	{
		var frm = document.forms['meludi'];
		var projectFocus = frm.projectFocus.value;

		streg.mutationAnalysisReset();
		
		if (projectFocus == 'melanoma')
		{
			frm.mutationAnalysisNras.checked = true;
			frm.mutationAnalysisBraf.checked = true;
			frm.mutationAnalysisKit.checked = true;
			return;
		}
		if (projectFocus == 'lungcancer')
		{
			frm.mutationAnalysisKras.checked = true;
			frm.mutationAnalysisEgfr.checked = true;
			return;
		}
		if (projectFocus == 'coloncancer')
		{
			frm.mutationAnalysisKras.checked = true;
			frm.mutationAnalysisNras.checked = true;
			frm.mutationAnalysisBraf.checked = true;
			return;
		}
		if (projectFocus == 'GIST')
		{
			frm.mutationAnalysisPdgfra.checked = true;
			frm.mutationAnalysisKit.checked = true;
			return;
		}
	}

	streg.mutationAnalysisReset = function()
	{
		var frm = document.forms['meludi'];

		frm.mutationAnalysisKras.checked = false;
		frm.mutationAnalysisNras.checked = false;
		frm.mutationAnalysisBraf.checked = false;
		frm.mutationAnalysisEgfr.checked = false;
		frm.mutationAnalysisAlkEml4.checked = false;
		frm.mutationAnalysisPdgfra.checked = false;
		frm.mutationAnalysisKit.checked = false;
		frm.mutationAnalysisOther.checked = false;
	}

	streg.viableTumourCellsPercentOnChange = function()
	{
		viableTumourCellsPercentIsValid = false;

		var frm = document.forms['meludi'];
		var viableTumourCellsPercent = frm.viableTumourCellsPercent.value;
		
		if (viableTumourCellsPercent != null)
		{
			if (parseInt(viableTumourCellsPercent) < 0)
			{
				Wizard.setInputStatus('viableTumourCellsPercent', 'invalid', 'Must be at least 0');
				return;		
			}
			if (parseInt(viableTumourCellsPercent) > 100)
			{
				Wizard.setInputStatus('viableTumourCellsPercent', 'invalid', 'Must be at most 100');
				return;		
			}
		}
		Wizard.setInputStatus('viableTumourCellsPercent', 'valid');
		viableTumourCellsPercentIsValid = true; 
	}

	streg.validateStep2 = function(event)
	{
		var valid = true;
		var frm = document.forms['meludi'];	

		valid &= nofTubesIsValid;
		valid &= Wizard.isValid('arrivalDate');
		valid &= samplingDateIsValid;
		valid &= viableTumourCellsPercentIsValid;
		
		if (!valid) event.preventDefault();
	}

	streg.initializeStep3 = function()
	{
		var frm = document.forms['meludi'];
		var tubeContentType = frm.tubeContentType.value;
		var nofTubes = parseInt(frm.nofTubes.value);
		nofTubes = streg.fixNofTubes(tubeContentType, nofTubes);
		frm.nofTubes.value = nofTubes;
		var storageBoxSuffix = streg.fetchStorageBoxSuffix(tubeContentType);
		if (nofTubes > 2) Doc.addClass('step-2', 'auto-hide');
		
		var html = '';
		for (var i=0; i < nofTubes; i++)
		{
			var tubeContentTypeName = streg.fetchTubeContentTypeName(tubeContentType, i);
			var tubeContentTypeNameInternal = streg.fetchTubeContentTypeNameInternal(tubeContentType, tubeContentTypeName);
			var tubeName = streg.fetchTubeName(tubeContentType, caseInfo, i);
			var tubeNo = i+caseInfo.specimenFirstIndex;
			var tubeIdentifier = streg.fetchTubeIdentifier(tubeContentType, tubeName, tubeNo);
			html += '<tr class="section-header">';
			html += '<td colspan="4">'+tubeContentTypeName+' Tube '+tubeName+'</td>';
			html += '</tr>';

			var boxMsg = 'Box-number where the '+tubeContentTypeNameInternal+' tube is located in.';
			var disabledAttribute = '';
			if (i == 0 && tubeContentType != 'RNA')
			{
				boxMsg = 'No storage space is allocated for first '+tubeContentTypeNameInternal+', since all amount is expected to be used for analysis.';
				disabledAttribute = ' disabled';
			}	
			html += '<tr>';
			html += '<td class="subprompt">Box</td>';
			html += '<td class="input">';
			html += '<input type="text" name="box.'+i+'" id="box.'+i+'" style="width: 12em;" maxlength="12"'+disabledAttribute+'></td>';
			html += '<td class="status" id="box.'+i+'.status"></td>';
			html += '<td class="help"><span id="box.'+i+'.message" class="message"></span>'+boxMsg+'</td>';
			html += '</tr>';
			
			html += '<tr>';
			html += '<td class="subprompt">Row</td>';
			html += '<td class="input">';
			html += '<input type="text" name="row.'+i+'" id="row.'+i+'" style="text-transform:uppercase; width: 3em;" maxlength="2"'+disabledAttribute+'>';
			html += '&nbsp;Column<input type="text" name="column.'+i+'" id="column.'+i+'" style="width: 3em;" maxlength="2"'+disabledAttribute+'>';
			html += '</td>';
			html += '<td class="status" id="position.'+i+'.status"></td>';
			html += '<td class="help"><span id="position.'+i+'.message" class="message"></span></td>';		
			html += '</tr>';

			if (tubeContentType == 'Specimen')
			{
				html += '<tr>';
				html += '<td class="subprompt">Number of sections</td>';
				html += '<td class="input">';
				html += '<input type="text" name="nofSections.'+i+'" id="nofSections.'+i+'" style="width: 3em;" maxlength="2" value="1">';
				html += '</td>';
				html += '<td class="status" id="nofSections.'+i+'.status"></td>';
				html += '<td class="help"><span id="nofSections.'+i+'.message" class="message"></span>Number of sections (slices) in FFPE block.</td>';		
				html += '</tr>';
			}

			html += '<tr class="align-top">';
			html += '<td class="subprompt">Operator delivery comment</td>';
			html += '<td class="input"><textarea rows="3" name="comment.'+i+'" id="comment.'+i+'"></textarea></td>';
			html += '<td class="status" id="comment.'+i+'.status"></td>';
			html += '<td class="help"><span id="comment.'+i+'.message" class="message"></span>In this field, enter information specific for '+tubeContentTypeNameInternal+' tube ' +tubeIdentifier+'.</td>';		
			html += '</tr>';
		}
		Doc.element('specimen-tubes').innerHTML = html;

		Wizard.setCurrentStep(3);
		Doc.show('goregister');
		Doc.show('gocancel');
		frm['comment.0'].focus();
		
		var url = '../SpecimenTubeRegistration.servlet?ID='+App.getSessionId();
		url += '&cmd=FindStoragePositions';	
		url += '&nofTubes='+frm.nofTubes.value;
		url += '&storageBoxSuffix='+storageBoxSuffix;
		
		Wizard.showLoadingAnimation('Looking for empty box positions...');
		Wizard.asyncJsonRequest(url, streg.storagePositionsLoaded);
	}
	
	streg.storagePositionsLoaded = function(response)
	{
		var freeWells = response.wells;
		var frm = document.forms['meludi'];
		var tubeContentType = frm.tubeContentType.value;
		var nofTubes = parseInt(frm.nofTubes.value);

		// No storage space is allocated for first specimen,
		// since all amount is expected to be used for analysis.
		// Specimen tube with i == 0 is therefore skipped.
		var startIndex = 1;
		if (tubeContentType == 'RNA')
		{
			startIndex = 0;
		}
		for (var i = startIndex; i < nofTubes; i++)
		{
			var wellIndex = i-1;
			if (tubeContentType == 'RNA')
			{
				wellIndex = i;
			}
			var well = freeWells[wellIndex];
			if (!well || well == '') 
			{
				Wizard.setInputStatus('box.'+i, 'invalid', 'Missing box');
				return;
			}
			frm['box.'+i].value = well.bioPlate.name;
			frm['row.'+i].value = Meludi.wellToAlpha(well.row);
			frm['column.'+i].value = well.column+1;
			
			// Move focus to next field
			Events.addEventHandler('box.'+i, 'keypress', Wizard.focusOnEnter, { 'next-focus': 'row.'+i });
			Events.addEventHandler('row.'+i, 'keypress', Wizard.focusOnEnter, { 'next-focus': 'column.'+i });
			Events.addEventHandler('column.'+i, 'keypress', Wizard.focusOnEnter, { 'next-focus': 'nofSections.'+i });
			Events.addEventHandler('nofSections.'+i, 'keypress', Wizard.focusOnEnter, { 'next-focus': 'comment.'+i });
			
			// Form validation
			Events.addEventHandler('column.'+i, 'keypress', Events.integerOnly);
			Events.addEventHandler('box.'+i, 'change', streg.wellOnChange, { 'index': i });
			Events.addEventHandler('row.'+i, 'change', streg.wellOnChange, { 'index': i });
			Events.addEventHandler('column.'+i, 'change', streg.wellOnChange, { 'index': i });
			Events.addEventHandler('box.'+i, 'keyup', streg.boxOnKeyUp);
			Events.addEventHandler('nofSections.'+i, 'keypress', Events.integerOnly);
			Events.addEventHandler('nofSections.'+i, 'change', streg.nofSectionsOnChange, { 'index': i });
			
			wellIsValid[i] = true;
			Wizard.setInputStatus('position.'+i, 'valid');
			Wizard.setInputStatus('box.'+i, 'valid');
			if (tubeContentType == 'Specimen')
			{
				Wizard.setInputStatus('nofSections.'+i, 'valid');
			}
		}
	}

	streg.fixNofTubes = function(tubeContentType, nofTubes)
	{
		if (tubeContentType == 'DNA')
		{
			nofTubes = 1;
		}
		else if (tubeContentType == 'RNA')
		{
			nofTubes = 1;
		}
		else if (tubeContentType == 'DNA_RNA')
		{
			nofTubes = 2;
		}
		return nofTubes;
	}
	
	streg.fetchStorageBoxSuffix = function(tubeContentType)
	{
		var storageBoxSuffix = null;
		if (tubeContentType == 'Specimen')
		{
			storageBoxSuffix = '_sp';
		}
		else if (tubeContentType == 'DNA')
		{
			storageBoxSuffix = null;
		}
		else if (tubeContentType == 'RNA')
		{
			storageBoxSuffix = '_rna';
		}
		else if (tubeContentType == 'DNA_RNA')
		{
			storageBoxSuffix = '_rna';
		}
		return storageBoxSuffix;
	}
	
	streg.fetchTubeContentTypeName = function(tubeContentType, tubeIndex)
	{
		var tubeContentTypeName = tubeContentType;
		if (tubeContentType == 'DNA_RNA')
		{
			if (tubeIndex == 0)
			{
				tubeContentTypeName = 'DNA';
			}
			else if (tubeIndex == 1)
			{
				tubeContentTypeName = 'RNA';
			}
		}
		return tubeContentTypeName;
	}
	
	streg.fetchTubeContentTypeNameInternal = function(tubeContentType, tubeContentTypeName)
	{
		var tubeContentTypeNameInternal = tubeContentTypeName;
		// Convert all names except abbreviations to all lower case
		if (tubeContentType == 'Specimen')
		{
			tubeContentTypeNameInternal = tubeContentTypeName.toLowerCase();
		}
		return tubeContentTypeNameInternal;
	}
	
	streg.fetchTubeName = function(tubeContentType, caseInfo, tubeIndex)
	{
		var tubeName = Strings.encodeTags(caseInfo.originalName);
		if (tubeContentType == 'Specimen')
		{
			var tubeNo = tubeIndex + caseInfo.specimenFirstIndex;
			tubeName = tubeName+'.'+tubeNo;
		}
		else if (tubeContentType == 'DNA')
		{
			tubeName = tubeName+'.d';
		}
		else if (tubeContentType == 'RNA')
		{
			tubeName = tubeName+'.r';
		}
		else if (tubeContentType == 'DNA_RNA')
		{
			if (tubeIndex == 0)
			{
				tubeName = tubeName+'.d';
			}
			else if (tubeIndex == 1)
			{
				tubeName = tubeName+'.r';
			}
		}
		return tubeName;
	}
	
	streg.fetchTubeIdentifier = function(tubeContentType, tubeName, tubeNo)
	{
		var tubeIdentifier = tubeName;
		if (tubeContentType == 'Specimen')
		{
			tubeIdentifier = tubeNo;
		}
		return tubeIdentifier;
	}
	
	streg.boxOnKeyUp = function(event)
	{
		var frm = document.forms['meludi'];
		var tubeContentType = frm.tubeContentType.value;
		
		var index = Data.int(event.currentTarget, 'index');

		// Check box name
		var boxIsValid = true;
		var box = frm['box.'+index].value;
		Wizard.setInputStatus('box.'+index);
		// Check for prefix "ML_"
		if (box.indexOf('ML_') != 0)
		{
			boxIsValid = false;
		}
		var suffix = '_sp';
		if (tubeContentType == 'RNA')
		{
			suffix = '_rna';
		}
		// Check for suffix
		if (box.indexOf(suffix) != (box.length - suffix.length))
		{
			boxIsValid = false;
		}
		
		if (!boxIsValid)
		{
			Wizard.setInputStatus('box.'+index, 'invalid', 'Box name must start with "ML_" and end with "'+suffix+'"');
			return;
		}
	}
	
	streg.wellOnChange = function(event)
	{
		var frm = document.forms['meludi'];
		var target = event.currentTarget;

		var index = Data.int(target, 'index');
		var box = frm['box.'+index].value;
		var row = frm['row.'+index].value;
		var column = frm['column.'+index].value;
		
		wellIsValid[index] = false;
		Wizard.setInputStatus('box.'+index);
		Wizard.setInputStatus('position.'+index);
		
		if (box == '') 
		{
			Wizard.setInputStatus('box.'+index, 'invalid', 'Missing box');
			return;
		}
		
		if (row == '')
		{
			Wizard.setInputStatus('position.'+index, 'invalid', 'Missing row');
			return;
		}

		if (column == '')
		{
			Wizard.setInputStatus('position.'+index, 'invalid', 'Missing column');
			return;
		}
		
		// Check for duplicates
		var nofTubes = parseInt(frm.nofTubes.value);
		for (var i=0; i < nofTubes; i++)
		{		
			if (i != index)
			{
				if (box == frm.elements['box.'+i].value && row == frm['row.'+i].value && column == frm['column.'+i].value)
				{
					Wizard.setInputStatus('position.'+index, 'invalid', 'The position is already used once in this wizard');				
					return;
				}
			}
		}

		Wizard.setInputStatus('position.'+index, 'checking', 'Checking...');
		
		// Seems to be ok -- check if used by another sample
		var request = Ajax.getXmlHttpRequest();
		var url = '../SpecimenTubeRegistration.servlet?ID='+App.getSessionId();
		url += '&cmd=ValidateWell';
		url += '&box=' + encodeURIComponent(box);	
		url += '&row=' + encodeURIComponent(row);
		url += '&column=' + encodeURIComponent(column);
		
		Wizard.asyncJsonRequest(url, function(response) { streg.onBoxValidated(response, index) } );
	}
	
	streg.onBoxValidated = function(response, index)
	{
		Wizard.setInputStatus('position.'+index);
		if (response.message)
		{
			Wizard.setInputStatus(response.box ? 'box.'+index : 'position.'+index, 'invalid', Strings.encodeTags(response.message));
			return;
		}
		
		wellIsValid[index] = true;
		Wizard.setInputStatus('box.'+index, 'valid');
		Wizard.setInputStatus('position.'+index, 'valid');
	}

	
	streg.nofSectionsOnChange = function(event)
	{
		var frm = document.forms['meludi'];
		var target = event.currentTarget;

		var index = Data.int(target, 'index');
		var nofSections = frm['nofSections.'+index].value;

		Wizard.setInputStatus('nofSections.'+index);

		if (nofSections == '')
		{
			Wizard.setInputStatus('nofSections'+index, 'invalid', 'Missing');
			return;
		}
		if (parseInt(nofSections) < 1)
		{
			Wizard.setInputStatus('nofSections'+index, 'invalid', 'Must be at least 1');
			return;		
		}
		Wizard.setInputStatus('nofSections'+index, 'valid');
	}

	streg.validateStep3 = function(event)
	{
		var valid = false;

		// No storage space is allocated for first specimen,
		// since all amount is expected to be used for analysis.
		// Specimen tube with i == 0 is therefore skipped.
		for (var i = 1; i < wellIsValid.length; i++)
		{
			if (!wellIsValid[i])
			{
				event.preventDefault();
				return;
			}
		}
	}

	
	streg.submit = function()
	{
		var frm = document.forms['meludi'];

		caseInfo.arrivalDate = Strings.trim(frm.arrivalDate.value);
		caseInfo.samplingDate = Strings.trim(frm.samplingDate.value);
		caseInfo.mutationAnalysisKras = frm.mutationAnalysisKras.checked;
		caseInfo.mutationAnalysisNras = frm.mutationAnalysisNras.checked;
		caseInfo.mutationAnalysisBraf = frm.mutationAnalysisBraf.checked;
		caseInfo.mutationAnalysisEgfr = frm.mutationAnalysisEgfr.checked;
		caseInfo.mutationAnalysisAlkEml4 = frm.mutationAnalysisAlkEml4.checked;
		caseInfo.mutationAnalysisPdgfra = frm.mutationAnalysisPdgfra.checked;
		caseInfo.mutationAnalysisKit = frm.mutationAnalysisKit.checked;
		caseInfo.mutationAnalysisOther = frm.mutationAnalysisOther.checked;
		caseInfo.site = frm.site.value;
		caseInfo.tubeContentType = frm.tubeContentType.value;
		caseInfo.specimenType = frm.specimenType.value;
		caseInfo.projectFocus = frm.projectFocus.value;
		caseInfo.viableTumourCellsPercent = frm.viableTumourCellsPercent.value;
		caseInfo.otherPathNote = frm.otherPathNote.value;
		
		var nofTubes = parseInt(frm.nofTubes.value);
		caseInfo.specimen = [];
		for (var i = 0; i < nofTubes; i++)
		{
			var specimenTube ={};
			specimenTube.name = streg.fetchTubeName(caseInfo.tubeContentType, caseInfo, i);
			specimenTube.box = frm['box.'+i].value;
			specimenTube.row = frm['row.'+i].value;
			specimenTube.column = frm['column.'+i].value;
			var nofSections = null;
			if (caseInfo.tubeContentType == 'Specimen')
			{
				nofSections = frm['nofSections.'+i].value;
			}
			specimenTube.nofSections = nofSections;
			specimenTube.comment = frm['comment.'+i].value;
			specimenTube.specimenType = frm.specimenType.value;
			caseInfo.specimen[i] = specimenTube;
		}

		var submitInfo = {};
		submitInfo.caseInfo = caseInfo;

		var url = '../SpecimenTubeRegistration.servlet?ID='+App.getSessionId();
		url += '&cmd=CreateSpecimenTubes';
		Wizard.showLoadingAnimation('Performing registration...');
		Wizard.asyncJsonRequest(url, streg.submissionResults, 'POST', JSON.stringify(submitInfo));
	}
	
	streg.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		Doc.show('gorestart');
		Doc.show('gonext-message');
	}

	streg.countDownToRestart = function()
	{
		var time = restartAt - (new Date()).getTime();
		if (time < 0)
		{
			Wizard.restartWizard();
		}
		else
		{
			Doc.element('gonext-message').innerHTML = '<i>Wizard will restart automatically in ' + Math.ceil(time/1000) + ' seconds...</i>';
		}
	}
	
	streg.stopAutoRestart = function()
	{
		clearTimeout(restartTimer);
		Doc.hide('gonext-message');
		Doc.hide('gostop');
	}

	streg.getCheckboxStatus = function(checkbox)
	{
		return checkbox.checked;
	}
	
	return streg;
}();

Doc.onLoad(SpecimenTubeReg.initPage);

